﻿' 空白ページのアイテム テンプレートについては、http://go.microsoft.com/fwlink/?LinkId=234238 を参照してください
Option Strict On

Imports Bing.Maps
Imports Windows.UI
Imports Windows.UI.Core
Imports System.Net.Http
Imports Windows.UI.Popups

''' <summary>
''' それ自体で使用できる空白ページまたはフレーム内に移動できる空白ページ。
''' </summary>
Public NotInheritable Class MainPage
    Inherits Page

    'Dim myLatitude As String
    'Dim myLongitude As String
    Dim myCoreDispacher As CoreDispatcher
    Const AppID As String = "qXDGISuxg67atI4gLyUd7jooKwQCGGcDhHivtN7RxokBQryudCudKCXedwS.FvYiWXW_kM8oo_5M"
    Dim xmldoc As XElement
    Dim no As Integer = 0
    Protected Overrides Async Sub OnNavigatedTo(e As Navigation.NavigationEventArgs)
      
        xmldoc = XElement.Load("Castle.xml")
        For Each result In From c In xmldoc.Descendants("Info") Select c
            Dim myImage As New Image
            With myImage
                .Width = 28
                .Height = 36
                .Source = New BitmapImage(New Uri("ms-appx:///Image/城.png"))
            End With
            Dim myLatitude = result.Element("Latitude").Value
            Dim myLongitude = result.Element("Longitude").Value
            Dim myLocation = New Location(CDbl(myLatitude), CDbl(myLongitude))
            MapLayer.SetPosition(myImage, myLocation)
            myMap.Children.Add(myImage)
            myMap.SetView(myLocation, 8)

            Dim myAddressUri As String = String.Format("http://reverse.search.olp.yahooapis.jp/OpenLocalPlatform/V1/reverseGeoCoder?lat={0}&lon={1}&appid={2}", CDbl(myLatitude), CDbl(myLongitude), AppID)
            Dim myAddressHttpClient As New HttpClient
            Dim myCurrentAddress = Await myAddressHttpClient.GetStringAsync(myAddressUri)
            myCurrentAddress = myCurrentAddress.Replace("<YDF firstResultPosition=" & ChrW(34) & "1" & ChrW(34) & " totalResultsAvailable=" & ChrW(34) & "1" & ChrW(34) & " totalResultsReturned=" & ChrW(34) & "1" & ChrW(34) & " xmlns=" & ChrW(34) & "http://olp.yahooapis.jp/ydf/1.0" & ChrW(34) & ">", "<YDF>")

            Dim doc As XElement = XElement.Parse(myCurrentAddress)
            Dim myAddress = doc.Descendants("Address").Value

            Dim myStackPanel As New StackPanel
            With myStackPanel
                .Background = New SolidColorBrush(Colors.Navy)
                .Margin = New Thickness(5)
                .Visibility = Xaml.Visibility.Collapsed
                .SetValue(Canvas.ZIndexProperty, no)
            End With
           
            Dim myAddressTextBlock As New TextBlock

            With myAddressTextBlock
                .FontSize = 22
                .Foreground = New SolidColorBrush(Colors.Crimson)
                .Width = 400
                .TextWrapping = TextWrapping.Wrap
                .Text = myAddress & "辺り"
                .Padding = New Thickness(5)
            End With

            Dim myCastleNameTextBlock As New TextBlock
            With myCastleNameTextBlock
                .FontSize = 24
                .Foreground = New SolidColorBrush(Colors.Gold)
                .Text = result.Element("Name").Value
                .Padding = New Thickness(5)
            End With

            Dim myButton As New Button
            With myButton
                .Content = "Webで検索"
                .Tag = no.ToString
            End With

            myStackPanel.Children.Add(myAddressTextBlock)
            myStackPanel.Children.Add(myCastleNameTextBlock)
            myStackPanel.Children.Add(myButton)

            MapLayer.SetPosition(myStackPanel, New Location(CDbl(myLatitude), CDbl(myLongitude)))
            myMap.Children.Add(myStackPanel)
            no += 1
            AddHandler myImage.Tapped, Sub()

                                           myStackPanel.Visibility = Xaml.Visibility.Visible
                                       End Sub

            AddHandler myStackPanel.Tapped, Sub()
                                                myStackPanel.Visibility = Xaml.Visibility.Collapsed
                                            End Sub

            AddHandler myButton.Click, Sub(mySender As Object, myArgs As RoutedEventArgs)
                                           myFrame.Visibility = Xaml.Visibility.Visible
                                           Dim Index = DirectCast(mySender, Button).Tag
                                           Dim myIndex = CInt(Index)
                                           Dim castleName = xmldoc.Descendants("Info")(myIndex).Element("Name").Value
                                           myFrame.Navigate(GetType(WebBrowserPage), castleName)
                                       End Sub


        Next
    End Sub

    Private Sub backButton_Click(sender As Object, e As RoutedEventArgs) Handles backButton.Click
        myFrame.Visibility = Xaml.Visibility.Collapsed
    End Sub
End Class
